/******************************************************************************

    Copyright (c) 1990-2010 Flexera Software, Inc. All Rights Reserved.
	This software has been provided pursuant to a License Agreement
	containing restrictions on its use.  This software contains
	valuable trade secrets and proprietary information of
	Flexera Software, Inc. and is protected by law.  It may
	not be copied or distributed in any form or medium, disclosed
	to third parties, reverse engineered or used in any manner not
	provided for in said License Agreement except with the prior
	written authorization from Flexera Software, Inc.

 *****************************************************************************/
/*

 *
 *	Description: FLEXnet error strings
 *
 *
 */

			"",				/* No error 0 */
/* NOCONFFILE */	"Cannot find license file.",
/* BADFILE */		"Invalid license file syntax.",
/* NOSERVER */		"No license server system for this feature.",
/* MAXUSERS */		"Licensed number of users already reached.",
/* NOFEATURE */		"No such feature exists.",
/* NOSERVICE */		"No port number in license file and \"FLEXnet\" service does not exist.",
/* NOSOCKET */		"No socket connection to license server manager.",
/* BADCODE */		"Invalid (inconsistent) license key.",
/* NOTTHISHOST */	"Invalid host.",
/* LONGGONE */		"Feature has expired.",
/* BADDATE */		"Invalid date format in license file.",
/* BADCOMM */		"Invalid returned data from license server system.",
/* NO_SERVER_IN_FILE */	"No SERVER lines in license file.",
/* BADHOST */		"Cannot find SERVER hostname in network database.",
/* CANTCONNECT */	"Cannot connect to license server system.",
/* CANTREAD */		"Cannot read data from license server system.",
/* CANTWRITE */		"Cannot write data to license server system.",
/* NOSERVSUPP */	"License server system does not support this feature.",
/* SELECTERR */		"Error in select system call.",
/* SERVBUSY */		"License server system busy (no majority).",
/* OLDVER */		"License file does not support this version.",
/* CHECKINBAD */	"Feature checkin failure detected with license server system.",
/* BUSYNEWSERV */	"License server system temporarily busy (new server connecting).",
/* USERSQUEUED */	"Users are queued for this feature.",
/* SERVLONGGONE */	"License server system does not support this version of this feature.",
/* TOOMANY */		"Request for more licenses than this feature supports.",
/* CANTREADKMEM */	"Cannot read /dev/kmem.",
/* CANTREADVMUNIX */	"Cannot read /vmunix.",
/* CANTFINDETHER */	"Cannot find ethernet device.",
/* NOREADLIC */		"Cannot read license file.",
/* TOOEARLY */		"Feature start date is in the future.",
/* NOSUCHATTR */	"No such attribute.",
/* BADHANDSHAKE */	"Bad encryption handshake with vendor daemon.",
/* CLOCKBAD */		"Clock difference too large between client and license server system.",
/* FEATQUEUE */		"In the queue for this feature.",
/* FEATCORRUPT */	"Feature database corrupted in vendor daemon.",
/* BADFEATPARAM */	"Duplicate selection mismatch for this feature.",
/* FEATEXCLUDE */	"User/host on EXCLUDE list for feature.",
/* FEATNOTINCLUDE */	"User/host not on INCLUDE list for feature.",
/* CANTMALLOC */	"Cannot allocate dynamic memory.",
/* NEVERCHECKOUT */	"Feature was never checked out.",
/* BADPARAM */		"Invalid parameter.",
/* NOKEYDATA */		"No key data supplied in call to lc_new_job() or lc_init().",
/* BADKEYDATA */	"Invalid key data supplied.",
/* FUNCNOTAVAIL */	"Function not available in this version.",
/* DEMOKIT */		"Software is evaluation version.",
/* NOCLOCKCHECK */	"Clock setting check not available in vendor daemon.",
/* BADPLATFORM */	"Platform not enabled.",
/* DATE_TOOBIG */	"Date invalid for binary format.",
/* EXPIREDKEYS */	"Key data has expired.",
/* NOFLEXLMINIT */	"Not initialized.",
/* NOSERVRESP */	"Vendor daemon did not respond within timeout interval.",
/* CHECKOUTFILTERED */	"Checkout request rejected by vendor-defined checkout filter.",
/* NOFEATSET */		"No FEATURESET line in license file.",
/* BADFEATSET */	"Incorrect FEATURESET line in license file.",
/* CANTCOMPUTEFEATSET */ "Cannot compute FEATURESET data from license file.",
/* SOCKETFAIL */ 	"socket() call failed.",
/* SETSOCKFAIL */	"setsockopt() call failed.",
/* BADCHECKSUM */	"Message checksum failure.",
/* SERVBADCHECKSUM */	"License server system message checksum failure.",
/* SERVNOREADLIC */	"Cannot read license file data from license server system.",
/* NONETWORK */		"Network software (tcp/ip) not available.",
/* NOTLICADMIN */	"You are not a license administrator.",
/* REMOVETOOSOON */	"lmremove request before the minimum lmremove interval.",
/* BADVENDORDATA */	"Unknown VENDORCODE struct type passed to lc_new_job() or lc_init().",
/* LIBRARYMISMATCH */	"Include file/library version mismatch.",
/* NONETOBORROW */	"No licenses available to borrow.",
/* NOBORROWSUPP */	"License BORROW support not enabled.",
/* LM_NOTONSERVER */ 	"FLOAT_OK can't run standalone on license server system.",
/* LM_BORROWLOCKED */	"Meter already being updated, locked.",
/* BAD_TZ */		"Invalid TZ environment variable.",
/* OLDVENDORDATA */	"Old VENDORCODE (3-word) struct type passed to lc_new_job() or lc_init().",
/* LOCALFILTER */	"Local checkout filter rejected request.",
/* LM_ENDPATH */	"Attempt to read beyond end of license file path.",
/* LM_VMS_SETIMR_FAILED */ "SYS$SETIMR call failed.",
/* LM_INTERNAL_ERROR */	"Internal Error - Please report to Flexera Software, Inc.",
/* LM_BAD_VERSION */	"Bad version number - must be floating point number, with no letters.",
/* LM_NOADMINAPI */	"FLEXadmin API functions not available.",
/* LM_NOFILEOPS */	 "Internal error -79.",
/* LM_NODATAFILE */	 "Internal error -80.",
/* LM_NOFILEVSEND */	 "Internal error -81.",
/* LM_BADPKG */	 	"Invalid PACKAGE line in license file.",
/* LM_SERVOLDVER */	"Version of vendor daemon is too old.",
/* LM_USERBASED	*/ 	"USER_BASED license has no specified users -- see license server system log.",
/* LM_NOSERVCAP	*/ 	"License server system does not support this request.",
/* LM_OBJECTUSED */	"License object already in use.",
/* LM_MAXLIMIT */	"Checkout exceeds MAX specified in options file.",
/* LM_BADSYSDATE */	"System clock has been set back.",
/* LM_PLATNOTLIC */	"This platform not authorized by license.",
/* LM_FUTURE_FILE */ "Future license file format or misspelling in license file.",
/* LM_DEFAULT_SEEDS */ 	"Encryption seeds are non-unique.",
/* LM_SERVER_REMOVED */ "Feature removed during lmreread, or wrong SERVER line hostid.",
/* LM_POOL */ 		"This feature is available in a different license pool.",
/* LM_LGEN_VER */     "Attempt to generate license with incompatible attributes.",
/* LM_NOT_THIS_HOST */  "Network connect to THIS_HOST failed.",
/* LM_HOSTDOWN */ 	"License server machine is down or not responding.",
/* LM_VENDOR_DOWN */ 	"The desired vendor daemon is down.",
/* LM_CANT_DECIMAL */ 	"This FEATURE line can't be converted to decimal format.",
/* LM_BADDECFILE */ 	"The decimal format license is typed incorrectly.",
/* LM_REMOVE_LINGER */ 	"Cannot remove a linger license.",
/* LM_RESVFOROTHERS */ 	"All licenses are reserved for others.",
/* LM_BORROW_ERROR */ 	"A FLEXid borrow error occurred.",
/* LM_TSOK_ERR */ "Cannot checkout an uncounted license within a Windows Terminal Services guest session.",
/* LM_BORROW_TOOLONG*/ 	"Cannot borrow that long.",
/* LM_UNBORROWED_ALREADY*/ "Feature already returned to license server system.",
/* LM_SERVER_MAXED_OUT*/ "License server system is out of network connections.",
/* LM_NOBORROWCOMP */ 	"Cannot borrow a PACKAGE component.",
/* LM_BORROW_METEREMPTY */ ".", /* unused */
/* LM_NOBORROWMETER */ 	".", /* unused */
/* LM_NODONGLE */ 	"Cannot read dongle: check dongle or driver.",
/* LM_NORESLINK */      "lmgr.res, Windows Resource file, not linked.",
/* LM_NODONGLEDRIVER */ "Missing Dongle Driver.",
/* LM_FLEXLOCK2CKOUT */ "",
/* LM_SIGN_REQ */ 	"SIGN= keyword required but missing from the license certificate.",
/* LM_PUBKEY_ERR */ 	"Error in Public Key package.",
/* LM_NOTRLSUPPORT */ 	"TRL not supported for this platform." ,
/* LM_BORROW_LINGER_ERR */ 	"BORROW failed.",
/* LM_BORROW_EXPIRED */ 	"BORROW period expired.",
/* LM_MUST_BE_LOCAL */ 	"lmdown/lmreread must be run on the license server machine.",
/* LM_BORROW_DOWN */ 	"Cannot lmdown the server when licenses are borrowed.",
/* LM_FLOATOK_ONEHOSTID */ "FLOAT_OK requires exactly one dongle hostid.",
/* LM_BORROW_DELETE_ERR */	"Unable to delete local borrow info.",
/* LM_BORROW_RETURN_EARLY_ERR */ "Returning a borrowed license early is not supported.",
/* LM_BORROW_RETURN_SERVER_ERR */ "Error returning borrowed license.",
/* LM_CANT_CHECKOUT_JUST_PACKAGE */ "A PACKAGE component must be specified.",
/* LM_COMPOSITEID_INIT_ERR */ "Composite hostid not initialized.",
/* LM_COMPOSITEID_ITEM_ERR */ "An item needed for composite hostid missing or invalid.",
/* LM_BORROW_MATCH_ERR */ "Error, borrowed license doesn't match any known server license.",
/* LM_NULLPOINTER	   */ "Internal Error (NULL pointer).",
/* LM_BADHANDLE		   */ "Internal Error (Bad handle).",
/* LM_EMPTYSTRING	   */ "Internal Error (Empty string).",
/* LM_BADMEMORYACCESS  */ "Internal Error (Bad memory access).",
/* LM_NOTSUPPORTED	   */ "Internal Error (Operation not supported).",
/* LM_NULL_JOB_HANDLE */  "Job handle is NULL.   .",
/* LM_EVENTLOG_INIT_ERR	*/	"Error enabling event log.",
/* LM_EVENTLOG_DISABLED	*/	"Event logging is disabled.",
/* LM_EVENTLOG_WRITE_ERR */	"Error writing to event log.",
/* LM_BADINDEX */			"Internal error (Bad index).",
/* LM_TIMEOUT	*/			"Timeout.",
/* LM_BADCOMMAND */			"Bad message command.",
/* LM_SOCKET_BROKEN_PIPE */	"Error writing to socket.  Peer has closed socket.",
/* LM_INVALID_SIGNATURE	*/ "Error, cannot generate version specific license tied to a single hostid, which is composite.",
/* LM_UNCOUNTED_NOT_SUPPORTED */ "Version-specific signatures are not supported for uncounted licenses.",
/* LM_REDUNDANT_SIGNATURES */ "License template contains redundant signature specifiers.",
/* LM_BADCODE_V71_LK */		"Invalid V71_LK signature.",
/* LM_BADCODE_V71_SIGN */	"Invalid V71_SIGN signature.",
/* LM_BADCODE_V80_LK */		"Invalid V80_LK signature.",
/* LM_BADCODE_V80_SIGN */	"Invalid V80_SIGN signature.",
/* LM_BADCODE_V81_LK */		"Invalid V81_LK signature.",
/* LM_BADCODE_V81_SIGN */	"Invalid V81_SIGN signature.",
/* LM_BADCODE_V81_SIGN2	*/	"Invalid V81_SIGN2 signature.",
/* LM_BADCODE_V84_LK */		"Invalid V84_LK signature.",
/* LM_BADCODE_V84_SIGN */	"Invalid V84_SIGN signature.",
/* LM_BADCODE_V84_SIGN2	*/	"Invalid V84_SIGN2 signature.",
/* LM_LK_REQ */				"License key required but missing from the license certificate.",
/* LM_BADAUTH	*/	        "Invalid AUTH={} signature.",
/* LM_REPAIR_NEEDED	*/      "Trusted Storage compromised; repair needed",
/* LM_TS_OPEN	*/      "Trusted Storage open failure",
/* LM_BAD_FULFILLMENT	*/      "Invalid fulfillment record",
/* LM_BAD_ACTREQ	*/      "Invalid activation request received",
/* LM_TS_NO_FULFILL_MATCH */    "No fulfillment exists in trusted storage which matches the request",
/* LM_BAD_ACT_RESP */		"Invalid activation response received",
/* LM_CANTRETURN */		"Cannot return the specified activation",
/* LM_RETURNEXCEEDSMAX */	"Return count(s) would exceed max for the fulfillment",
/* LM_NO_REPAIRS_LEFT */	"No repair count left",
/* LM_NOT_ALLOWED */		"Specified operation is not allowed.",
/* LM_ENTLEXCLUDE */		"User/host on EXCLUDE list for entitlement.",
/* LM_ENTLNOTINCLUDE */		"User/host not in INCLUDE list for entitlement.",
/* LM_ACTIVATION */		"Activation error",
/* LM_TS_BADDATE */	"Invalid date format in trusted storage.",
/* LM_ENCRYPTION_FAILED */  "Message Encryption failed",
/* LM_DECRYPTION_FAILED */  "Message Decryption failed",
/* LM_BADCONTEXT */         "Bad Filter Context",
/* LM_SUPERSEDE_CONFLICT */	" SUPERSEDE feature conflict",
/* LM_INVALID_SUPERSEDE_SIGN */	" Invalid SUPERSEDE_SIGN syntax",
/* LM_SUPERSEDE_SIGN_EMPTYSTRING */	"SUPERSEDE_SIGN does not contain a feature name and license signature",
/* LM_ONE_TSOK_PLATFORM_ERR */ "ONE_TS_OK is not supported in this Windows Platform.",
/* LM_ONE_TSOK_MTX_ERR */   "Internal Error - 178. Please report to Flexera Software, Inc.",
/* LM_ONE_TSOK_ERR */		"Only One Terminal Server Remote Client checkout is allowed for this feature.",
/* LM_SSIDNULL */			"Internal Error - 180. Please report to Flexera Software, Inc.",
/* LM_SMTXNOTREL */			"Internal Error - 181. Please report to Flexera Software, Inc.",
/* LM_MTXNOPERM  */         "Internal Error - 182. Please report to Flexera Software, Inc.",
/* LM_COMPOSITEID_ETHER_ERR */ "More than one ethernet hostid not supported in composite hostid definition.",
/* LM_LIC_FILE_CHAR_EXCEED */ "The number of characters in the license file paths exceeds the permissible limit.",
/* LM_TZ_INVALID_SYNTAX */ "Invalid TZ keyword syntax.",
/* LM_TZ_INVALID_TZONE_SPEC */ "Invalid time zone override specification in the client.",
/* LM_TZ_INVALID_TZONE_INFO */ "The time zone information could not be obtained.",
/* LM_TZ_UNAUTHORIZED */ "License client time zone not authorized for license rights.",
/* LM_INVALID_VM_PLATFORMS */ "Invalid syntax for VM_PLATFORMS keyword.",
/* LM_VM_PHYSICAL_ONLY */ "Feature can be checked out from Physical machine only.",
/* LM_VM_VIRTUAL_ONLY */ "FEATURE can be checked out from Virtual machine only.",
/* LM_VM_NOT_SUPPORT */ "VM platform not authorized by license.",
/* LM_VM_BAD_KEY */ "FNP vendor keys do not support Virtualization feature.",
/* LM_MAXLIMIT_EXCEED */ "Checkout request denied as it exceeds the MAX limit specified in the options file.",
/* LM_BA_API_INTERNAL_ERROR */ "Binding agent API - Internal error.",
/* LM_BA_COMM_ERROR */ "Binding agent communication error.",
/* LM_INVALID_BA_VERSION */ "Invalid Binding agent version."
